%global pkgvers 4
%global scdate0 20190828
%global schash0 7d2a4e9931a82adc3814275b6219a03e24e36b4c
%global branch0 master
%global source0 https://github.com/pytorch/qnnpack.git

%global sshort0 %{expand:%%{lua:print(('%{schash0}'):sub(1,8))}}

Name:           qnnpack
Version:        0
Release:        %{scdate0}.%{pkgvers}.git%{sshort0}%{?dist}
Summary:        Quantized Neural Networks PACKage
License:        BSD

URL:            https://github.com/pytorch/qnnpack

BuildRequires:  cmake gcc-c++ git
BuildRequires:  fp16-devel psimd-devel fxdiv-devel cpuinfo-devel pthreadpool-devel

%global __cmake_in_source_build 1

%description
A mobile-optimized library for low-precision high-performance
neural network inference. QNNPACK provides implementation of
common neural network operators on quantized 8-bit tensors.

%package        devel
Summary:        Development files
Requires:       %{name} = %{version}-%{release}

%description    devel
This package contains the development files.


%prep
%setup -T -c -n %{name}
git clone --depth 1 -n -b %{branch0} %{source0} .
git fetch --depth 1 origin %{schash0}
git reset --hard %{schash0}
git log --format=fuller
# externals
sed -i '/PRIVATE fp16/d' CMakeLists.txt
sed -i '/PRIVATE psimd/d' CMakeLists.txt
sed -i '/PRIVATE fxdiv/d' CMakeLists.txt
sed -i '/NOT TARGET/,/ENDIF/d' CMakeLists.txt
sed -i 's|PROPERTIES PUBLIC_HEADER include/qnnpack.h|PROPERTIES PUBLIC_HEADER include/qnnpack.h SOVERSION 1 VERSION 1.0|g' CMakeLists.txt
# local clog
sed -i 's|qnnpack PUBLIC include|qnnpack PUBLIC include deps/clog/include|' CMakeLists.txt
sed -i 's|qnnpack PRIVATE clog|qnnpack PRIVATE %{_builddir}/%{name}/deps/clog/libclog.a|' CMakeLists.txt
sed -i 's|clog PROPERTIES PUBLIC_HEADER|clog PROPERTIES COMPILE_OPTIONS -fPIC PUBLIC_HEADER|g' deps/clog/CMakeLists.txt


%build
pushd deps/clog
cmake . -DCLOG_BUILD_TESTS=OFF
make %{?_smp_mflags}
popd

mkdir build
pushd build
%cmake .. -Wno-dev \
       -DCMAKE_SKIP_RPATH=ON \
       -DCMAKE_VERBOSE_MAKEFILE=OFF \
       -DCMAKE_BUILD_TYPE=RelWithDebInfo \
       -DQNNPACK_BUILD_TESTS=OFF \
       -DQNNPACK_BUILD_BENCHMARKS=OFF \
       -DFP16_SOURCE_DIR="%{_includedir}" \
       -DPSIMD_SOURCE_DIR="%{_includedir}" \
       -DFXDIV_SOURCE_DIR="%{_includedir}" \
       -DCPUINFO_SOURCE_DIR="%{_includedir}" \
       -DPTHREADPOOL_SOURCE_DIR="%{_includedir}"

make %{?_smp_mflags}
popd


%install
rm -rf %{buildroot}
pushd build
make install DESTDIR=%{buildroot}
popd

mkdir -p %{buildroot}%{_libdir}
mv -f %{buildroot}/usr/lib/* %{buildroot}%{_libdir}/

rm -rf %{buildroot}/%{_includedir}/gmock
rm -rf %{buildroot}/%{_includedir}/gtest
rm -rf %{buildroot}/%{_libdir}/*.a


%files
%license LICENSE
%doc README.md
%{_libdir}/lib*.so.*

%files devel
%license LICENSE
%doc README.md
%{_includedir}/*
%{_libdir}/lib*.so


%changelog
* Tue Jul 11 2017 Cristian Balint <cristian.balint@gmail.com>
- github update releases
